import os

import pdfplumber


class BasicIndexer():
    """Add a single pdf file to the index"""

    def __init__(self, index, image_dir, slide_dir):
        self.index = index
        self.image_dir = image_dir
        self.slide_dir = slide_dir
        self.process_images = True
        self.title_row = 0

    def skip_images(self):
        self.process_images = False

    def add_pdf(self, file_path):
        pdf = pdfplumber.open(file_path)
        for i, page in enumerate(pdf.pages):
            text = page.extract_text()
            self.index.add(str(file_path), i, text, text.split("\n")[self.title_row])
            if self.process_images:
                img_name = file_path.split(os.sep)[-1] + "_" + str(i) + ".jpg"
                img_path = os.path.join(self.image_dir, img_name)
                page.to_image().save(img_path)
